Index: src/language/dictionary/missing-values.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/missing-values.c,v
retrieving revision 1.10
diff -b -w -U3 -r1.10 missing-values.c
--- src/language/dictionary/missing-values.c	3 Nov 2006 04:53:51 -0000	1.10
+++ src/language/dictionary/missing-values.c	11 Nov 2006 00:13:14 -0000
@@ -37,7 +37,7 @@
 #define _(msgid) gettext (msgid)
 
 int
-cmd_missing_values (struct dataset *ds)
+cmd_missing_values (struct lexer *lexer, struct dataset *ds)
 {
   struct variable **v;
   size_t nv;
@@ -45,23 +45,23 @@
   int retval = CMD_FAILURE;
   bool deferred_errors = false;
 
-  while (token != '.')
+  while (lex_token (lexer) != '.')
     {
       size_t i;
 
-      if (!parse_variables (dataset_dict (ds), &v, &nv, PV_NONE)) 
+      if (!parse_variables (lexer, dataset_dict (ds), &v, &nv, PV_NONE)) 
         goto done;
 
-      if (!lex_match ('('))
+      if (!lex_match (lexer, '('))
         {
-          lex_error (_("expecting `('"));
+          lex_error (lexer, _("expecting `('"));
           goto done;
         }
 
       for (i = 0; i < nv; i++)
         mv_init (&v[i]->miss, v[i]->width);
 
-      if (!lex_match (')')) 
+      if (!lex_match (lexer, ')')) 
         {
           struct missing_values mv;
 
@@ -79,12 +79,12 @@
           if (v[0]->type == NUMERIC) 
             {
               mv_init (&mv, 0);
-              while (!lex_match (')'))
+              while (!lex_match (lexer, ')'))
                 {
                   double x, y;
                   bool ok;
 
-                  if (!parse_num_range (&x, &y, &v[0]->print))
+                  if (!parse_num_range (lexer, &x, &y, &v[0]->print))
                     goto done;
                   
                   ok = (x == y
@@ -93,35 +93,39 @@
                   if (!ok)
                     deferred_errors = true;
 
-                  lex_match (',');
+                  lex_match (lexer, ',');
                 }
             }
           else 
             {
+	      struct string value;
+
               mv_init (&mv, MAX_SHORT_STRING);
-              while (!lex_match (')')) 
+              while (!lex_match (lexer, ')')) 
                 {
-                  if (!lex_force_string ())
+                  if (!lex_force_string (lexer))
                     {
                       deferred_errors = true;
                       break;
                     }
 
-                  if (ds_length (&tokstr) > MAX_SHORT_STRING) 
+		  ds_init_string (&value, lex_tokstr (lexer));
+
+                  if (ds_length (&value) > MAX_SHORT_STRING) 
                     {
-                      ds_truncate (&tokstr, MAX_SHORT_STRING);
+                      ds_truncate (&value, MAX_SHORT_STRING);
                       msg (SE, _("Truncating missing value to short string "
                                  "length (%d characters)."),
                            MAX_SHORT_STRING);
                     }
                   else
-                    ds_rpad (&tokstr, MAX_SHORT_STRING, ' ');
+                    ds_rpad (&value, MAX_SHORT_STRING, ' ');
 
-                  if (!mv_add_str (&mv, ds_data (&tokstr)))
+                  if (!mv_add_str (&mv, ds_data (&value)))
                     deferred_errors = true;
 
-                  lex_get ();
-                  lex_match (',');
+                  lex_get (lexer);
+                  lex_match (lexer, ',');
                 }
             }
           
@@ -142,11 +146,11 @@
             }
         }
 
-      lex_match ('/');
+      lex_match (lexer, '/');
       free (v);
       v = NULL;
     }
-  retval = lex_end_of_command ();
+  retval = lex_end_of_command (lexer);
   
  done:
   free (v);
Index: src/language/dictionary/modify-variables.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/modify-variables.c,v
retrieving revision 1.11
diff -b -w -U3 -r1.11 modify-variables.c
--- src/language/dictionary/modify-variables.c	29 Oct 2006 09:51:36 -0000	1.11
+++ src/language/dictionary/modify-variables.c	11 Nov 2006 00:13:14 -0000
@@ -78,7 +78,7 @@
 
 /* Performs MODIFY VARS command. */
 int
-cmd_modify_vars (struct dataset *ds)
+cmd_modify_vars (struct lexer *lexer, struct dataset *ds)
 {
   /* Bits indicated whether we've already encountered a subcommand of
      this type. */
@@ -105,10 +105,10 @@
   vm.drop_cnt = 0;
 
   /* Parse each subcommand. */
-  lex_match ('/');
+  lex_match (lexer, '/');
   for (;;)
     {
-      if (lex_match_id ("REORDER"))
+      if (lex_match_id (lexer, "REORDER"))
 	{
 	  struct variable **v = NULL;
 	  size_t nv = 0;
@@ -120,21 +120,21 @@
 	    }
 	  already_encountered |= 1;
 
-	  lex_match ('=');
+	  lex_match (lexer, '=');
 	  do
 	    {
               struct ordering ordering;
 	      size_t prev_nv = nv;
 
 	      ordering.forward = ordering.positional = 1;
-	      if (lex_match_id ("FORWARD"));
-	      else if (lex_match_id ("BACKWARD"))
+	      if (lex_match_id (lexer, "FORWARD"));
+	      else if (lex_match_id (lexer, "BACKWARD"))
 		ordering.forward = 0;
-	      if (lex_match_id ("POSITIONAL"));
-	      else if (lex_match_id ("ALPHA"))
+	      if (lex_match_id (lexer, "POSITIONAL"));
+	      else if (lex_match_id (lexer, "ALPHA"))
 		ordering.positional = 0;
 
-	      if (lex_match (T_ALL) || token == '/' || token == '.')
+	      if (lex_match (lexer, T_ALL) || lex_token (lexer) == '/' || lex_token (lexer) == '.')
 		{
 		  if (prev_nv != 0)
 		    {
@@ -146,19 +146,19 @@
 		}
 	      else
 		{
-		  if (!lex_match ('('))
+		  if (!lex_match (lexer, '('))
 		    {
 		      msg (SE, _("`(' expected on REORDER subcommand."));
 		      free (v);
 		      goto done;
 		    }
-		  if (!parse_variables (dataset_dict (ds), &v, &nv,
+		  if (!parse_variables (lexer, dataset_dict (ds), &v, &nv,
 					PV_APPEND | PV_NO_DUPLICATE))
 		    {
 		      free (v);
 		      goto done;
 		    }
-		  if (!lex_match (')'))
+		  if (!lex_match (lexer, ')'))
 		    {
 		      msg (SE, _("`)' expected following variable names on "
 			   "REORDER subcommand."));
@@ -169,12 +169,12 @@
 	      sort (&v[prev_nv], nv - prev_nv, sizeof *v,
                     compare_variables_given_ordering, &ordering);
 	    }
-	  while (token != '/' && token != '.');
+	  while (lex_token (lexer) != '/' && lex_token (lexer) != '.');
 
 	  vm.reorder_vars = v;
           vm.reorder_cnt = nv;
 	}
-      else if (lex_match_id ("RENAME"))
+      else if (lex_match_id (lexer, "RENAME"))
 	{
 	  if (already_encountered & 2)
 	    {
@@ -183,27 +183,29 @@
 	    }
 	  already_encountered |= 2;
 
-	  lex_match ('=');
+	  lex_match (lexer, '=');
 	  do
 	    {
 	      size_t prev_nv_1 = vm.rename_cnt;
 	      size_t prev_nv_2 = vm.rename_cnt;
 
-	      if (!lex_match ('('))
+	      if (!lex_match (lexer, '('))
 		{
 		  msg (SE, _("`(' expected on RENAME subcommand."));
 		  goto done;
 		}
-	      if (!parse_variables (dataset_dict (ds), &vm.rename_vars, &vm.rename_cnt,
+	      if (!parse_variables (lexer, dataset_dict (ds), 
+				    &vm.rename_vars, &vm.rename_cnt,
 				    PV_APPEND | PV_NO_DUPLICATE))
 		goto done;
-	      if (!lex_match ('='))
+	      if (!lex_match (lexer, '='))
 		{
 		  msg (SE, _("`=' expected between lists of new and old variable "
 		       "names on RENAME subcommand."));
 		  goto done;
 		}
-	      if (!parse_DATA_LIST_vars (&vm.new_names, &prev_nv_1, PV_APPEND))
+	      if (!parse_DATA_LIST_vars (lexer, &vm.new_names, 
+					 &prev_nv_1, PV_APPEND))
 		goto done;
 	      if (prev_nv_1 != vm.rename_cnt)
 		{
@@ -216,16 +218,16 @@
 		  vm.new_names = NULL;
 		  goto done;
 		}
-	      if (!lex_match (')'))
+	      if (!lex_match (lexer, ')'))
 		{
 		  msg (SE, _("`)' expected after variable lists on RENAME "
 		       "subcommand."));
 		  goto done;
 		}
 	    }
-	  while (token != '.' && token != '/');
+	  while (lex_token (lexer) != '.' && lex_token (lexer) != '/');
 	}
-      else if (lex_match_id ("KEEP"))
+      else if (lex_match_id (lexer, "KEEP"))
 	{
 	  struct variable **keep_vars, **all_vars, **drop_vars;
 	  size_t keep_cnt, all_cnt, drop_cnt;
@@ -238,8 +240,8 @@
 	    }
 	  already_encountered |= 4;
 
-	  lex_match ('=');
-	  if (!parse_variables (dataset_dict (ds), &keep_vars, &keep_cnt, PV_NONE))
+	  lex_match (lexer, '=');
+	  if (!parse_variables (lexer, dataset_dict (ds), &keep_vars, &keep_cnt, PV_NONE))
 	    goto done;
 
 	  /* Transform the list of variables to keep into a list of
@@ -268,7 +270,7 @@
           vm.drop_vars = drop_vars;
           vm.drop_cnt = drop_cnt;
 	}
-      else if (lex_match_id ("DROP"))
+      else if (lex_match_id (lexer, "DROP"))
 	{
 	  struct variable **drop_vars;
 	  size_t drop_cnt;
@@ -282,13 +284,13 @@
 	    }
 	  already_encountered |= 4;
 
-	  lex_match ('=');
-	  if (!parse_variables (dataset_dict (ds), &drop_vars, &drop_cnt, PV_NONE))
+	  lex_match (lexer, '=');
+	  if (!parse_variables (lexer, dataset_dict (ds), &drop_vars, &drop_cnt, PV_NONE))
 	    goto done;
           vm.drop_vars = drop_vars;
           vm.drop_cnt = drop_cnt;
 	}
-      else if (lex_match_id ("MAP"))
+      else if (lex_match_id (lexer, "MAP"))
 	{
           struct dictionary *temp = dict_clone (dataset_dict (ds));
           int success = rearrange_dict (temp, &vm);
@@ -300,21 +302,21 @@
 	}
       else
 	{
-	  if (token == T_ID)
-	    msg (SE, _("Unrecognized subcommand name `%s'."), tokid);
+	  if (lex_token (lexer) == T_ID)
+	    msg (SE, _("Unrecognized subcommand name `%s'."), lex_tokid (lexer));
 	  else
 	    msg (SE, _("Subcommand name expected."));
 	  goto done;
 	}
 
-      if (token == '.')
+      if (lex_token (lexer) == '.')
 	break;
-      if (token != '/')
+      if (lex_token (lexer) != '/')
 	{
 	  msg (SE, _("`/' or `.' expected."));
 	  goto done;
 	}
-      lex_get ();
+      lex_get (lexer);
     }
 
   if (already_encountered & (1 | 4))
Index: src/language/dictionary/numeric.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/numeric.c,v
retrieving revision 1.15
diff -b -w -U3 -r1.15 numeric.c
--- src/language/dictionary/numeric.c	5 Nov 2006 05:20:53 -0000	1.15
+++ src/language/dictionary/numeric.c	11 Nov 2006 00:13:14 -0000
@@ -37,7 +37,7 @@
 
 /* Parses the NUMERIC command. */
 int
-cmd_numeric (struct dataset *ds)
+cmd_numeric (struct lexer *lexer, struct dataset *ds)
 {
   size_t i;
 
@@ -51,13 +51,13 @@
 
   do
     {
-      if (!parse_DATA_LIST_vars (&v, &nv, PV_NONE))
+      if (!parse_DATA_LIST_vars (lexer, &v, &nv, PV_NONE))
 	return CMD_FAILURE;
 
       /* Get the optional format specification. */
-      if (lex_match ('('))
+      if (lex_match (lexer, '('))
 	{
-	  if (!parse_format_specifier (&f))
+	  if (!parse_format_specifier (lexer, &f))
 	    goto fail;
 	  if (fmt_is_string (f.type))
 	    {
@@ -67,7 +67,7 @@
 	      goto fail;
 	    }
 
-	  if (!lex_match (')'))
+	  if (!lex_match (lexer, ')'))
 	    {
 	      msg (SE, _("`)' expected after output format."));
 	      goto fail;
@@ -94,9 +94,9 @@
 	free (v[i]);
       free (v);
     }
-  while (lex_match ('/'));
+  while (lex_match (lexer, '/'));
 
-  return lex_end_of_command ();
+  return lex_end_of_command (lexer);
 
   /* If we have an error at a point where cleanup is required,
      flow-of-control comes here. */
@@ -109,7 +109,7 @@
 
 /* Parses the STRING command. */
 int
-cmd_string (struct dataset *ds)
+cmd_string (struct lexer *lexer, struct dataset *ds)
 {
   size_t i;
 
@@ -125,12 +125,12 @@
 
   do
     {
-      if (!parse_DATA_LIST_vars (&v, &nv, PV_NONE))
+      if (!parse_DATA_LIST_vars (lexer, &v, &nv, PV_NONE))
 	return CMD_FAILURE;
 
-      if (!lex_force_match ('(')
-          || !parse_format_specifier (&f)
-          || !lex_force_match (')'))
+      if (!lex_force_match (lexer, '(')
+          || !parse_format_specifier (lexer, &f)
+          || !lex_force_match (lexer, ')'))
 	goto fail;
       if (!fmt_is_string (f.type))
 	{
@@ -160,9 +160,9 @@
 	free (v[i]);
       free (v);
     }
-  while (lex_match ('/'));
+  while (lex_match (lexer, '/'));
 
-  return lex_end_of_command ();
+  return lex_end_of_command (lexer);
 
   /* If we have an error at a point where cleanup is required,
      flow-of-control comes here. */
@@ -175,18 +175,18 @@
 
 /* Parses the LEAVE command. */
 int
-cmd_leave (struct dataset *ds)
+cmd_leave (struct lexer *lexer, struct dataset *ds)
 {
   struct variable **v;
   size_t nv;
 
   size_t i;
 
-  if (!parse_variables (dataset_dict (ds), &v, &nv, PV_NONE))
+  if (!parse_variables (lexer, dataset_dict (ds), &v, &nv, PV_NONE))
     return CMD_CASCADING_FAILURE;
   for (i = 0; i < nv; i++)
     v[i]->leave = true;
   free (v);
 
-  return lex_end_of_command ();
+  return lex_end_of_command (lexer);
 }
Index: src/language/dictionary/rename-variables.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/rename-variables.c,v
retrieving revision 1.7
diff -b -w -U3 -r1.7 rename-variables.c
--- src/language/dictionary/rename-variables.c	26 Oct 2006 06:16:36 -0000	1.7
+++ src/language/dictionary/rename-variables.c	11 Nov 2006 00:13:14 -0000
@@ -38,7 +38,7 @@
 /* The code for this function is very similar to the code for the
    RENAME subcommand of MODIFY VARS. */
 int
-cmd_rename_variables (struct dataset *ds)
+cmd_rename_variables (struct lexer *lexer, struct dataset *ds)
 {
   struct variable **rename_vars = NULL;
   char **rename_new_names = NULL;
@@ -56,20 +56,20 @@
       size_t prev_nv_1 = rename_cnt;
       size_t prev_nv_2 = rename_cnt;
 
-      if (!lex_match ('('))
+      if (!lex_match (lexer, '('))
 	{
 	  msg (SE, _("`(' expected."));
 	  goto lossage;
 	}
-      if (!parse_variables (dataset_dict (ds), &rename_vars, &rename_cnt,
+      if (!parse_variables (lexer, dataset_dict (ds), &rename_vars, &rename_cnt,
 			    PV_APPEND | PV_NO_DUPLICATE))
 	goto lossage;
-      if (!lex_match ('='))
+      if (!lex_match (lexer, '='))
 	{
 	  msg (SE, _("`=' expected between lists of new and old variable names."));
 	  goto lossage;
 	}
-      if (!parse_DATA_LIST_vars (&rename_new_names, &prev_nv_1, PV_APPEND))
+      if (!parse_DATA_LIST_vars (lexer, &rename_new_names, &prev_nv_1, PV_APPEND))
 	goto lossage;
       if (prev_nv_1 != rename_cnt)
 	{
@@ -85,13 +85,13 @@
 	  rename_new_names = NULL;
 	  goto lossage;
 	}
-      if (!lex_match (')'))
+      if (!lex_match (lexer, ')'))
 	{
 	  msg (SE, _("`)' expected after variable names."));
 	  goto lossage;
 	}
     }
-  while (token != '.');
+  while (lex_token (lexer) != '.');
 
   if (!dict_rename_vars (dataset_dict (ds),
                          rename_vars, rename_new_names, rename_cnt,
Index: src/language/dictionary/split-file.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/split-file.c,v
retrieving revision 1.10
diff -b -w -U3 -r1.10 split-file.c
--- src/language/dictionary/split-file.c	5 Nov 2006 05:20:53 -0000	1.10
+++ src/language/dictionary/split-file.c	11 Nov 2006 00:13:14 -0000
@@ -42,9 +42,9 @@
 #define _(msgid) gettext (msgid)
 
 int
-cmd_split_file (struct dataset *ds)
+cmd_split_file (struct lexer *lexer, struct dataset *ds)
 {
-  if (lex_match_id ("OFF"))
+  if (lex_match_id (lexer, "OFF"))
     dict_set_split_vars (dataset_dict (ds), NULL, 0);
   else
     {
@@ -52,17 +52,17 @@
       size_t n;
 
       /* For now, ignore SEPARATE and LAYERED. */
-      (void) ( lex_match_id ("SEPARATE") || lex_match_id ("LAYERED") );
+      (void) ( lex_match_id (lexer, "SEPARATE") || lex_match_id (lexer, "LAYERED") );
       
-      lex_match (T_BY);
-      if (!parse_variables (dataset_dict (ds), &v, &n, PV_NO_DUPLICATE))
+      lex_match (lexer, T_BY);
+      if (!parse_variables (lexer, dataset_dict (ds), &v, &n, PV_NO_DUPLICATE))
 	return CMD_CASCADING_FAILURE;
 
       dict_set_split_vars (dataset_dict (ds), v, n);
       free (v);
     }
 
-  return lex_end_of_command ();
+  return lex_end_of_command (lexer);
 }
 
 /* Dumps out the values of all the split variables for the case C. */
Index: src/language/dictionary/sys-file-info.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/sys-file-info.c,v
retrieving revision 1.13
diff -b -w -U3 -r1.13 sys-file-info.c
--- src/language/dictionary/sys-file-info.c	3 Nov 2006 04:53:51 -0000	1.13
+++ src/language/dictionary/sys-file-info.c	11 Nov 2006 00:13:15 -0000
@@ -78,7 +78,7 @@
 
 /* SYSFILE INFO utility. */
 int
-cmd_sysfile_info (struct dataset *ds UNUSED)
+cmd_sysfile_info (struct lexer *lexer, struct dataset *ds UNUSED)
 {
   struct file_handle *h;
   struct dictionary *d;
@@ -88,10 +88,10 @@
   int r, nr;
   int i;
 
-  lex_match_id ("FILE");
-  lex_match ('=');
+  lex_match_id (lexer, "FILE");
+  lex_match (lexer, '=');
 
-  h = fh_parse (FH_REF_FILE);
+  h = fh_parse (lexer, FH_REF_FILE);
   if (!h)
     return CMD_FAILURE;
 
@@ -170,7 +170,7 @@
 
   dict_destroy (d);
   
-  return lex_end_of_command ();
+  return lex_end_of_command (lexer);
 }
 
 /* DISPLAY utility. */
@@ -181,7 +181,7 @@
 static void display_vectors (const struct dictionary *dict, int sorted);
 
 int
-cmd_display (struct dataset *ds)
+cmd_display (struct lexer *lexer, struct dataset *ds)
 {
   /* Whether to sort the list of variables alphabetically. */
   int sorted;
@@ -190,14 +190,14 @@
   size_t n;
   struct variable **vl;
 
-  if (lex_match_id ("MACROS"))
+  if (lex_match_id (lexer, "MACROS"))
     display_macros ();
-  else if (lex_match_id ("DOCUMENTS"))
+  else if (lex_match_id (lexer, "DOCUMENTS"))
     display_documents (dataset_dict (ds));
-  else if (lex_match_id ("FILE"))
+  else if (lex_match_id (lexer, "FILE"))
     {
       som_blank_line ();
-      if (!lex_force_match_id ("LABEL"))
+      if (!lex_force_match_id (lexer, "LABEL"))
 	return CMD_FAILURE;
       if (dict_get_label (dataset_dict (ds)) == NULL)
 	tab_output_text (TAB_LEFT,
@@ -216,12 +216,12 @@
       const char **cp;
       int as;
 
-      sorted = lex_match_id ("SORTED");
+      sorted = lex_match_id (lexer, "SORTED");
 
       for (cp = sbc; *cp; cp++)
-	if (token == T_ID && lex_id_match (*cp, tokid))
+	if (lex_token (lexer) == T_ID && lex_id_match (*cp, lex_tokid (lexer)))
 	  {
-	    lex_get ();
+	    lex_get (lexer);
 	    break;
 	  }
       as = cp - sbc;
@@ -235,13 +235,13 @@
 	  return CMD_SUCCESS;
 	}
 
-      lex_match ('/');
-      lex_match_id ("VARIABLES");
-      lex_match ('=');
+      lex_match (lexer, '/');
+      lex_match_id (lexer, "VARIABLES");
+      lex_match (lexer, '=');
 
-      if (token != '.')
+      if (lex_token (lexer) != '.')
 	{
-	  if (!parse_variables (dataset_dict (ds), &vl, &n, PV_NONE))
+	  if (!parse_variables (lexer, dataset_dict (ds), &vl, &n, PV_NONE))
 	    {
 	      free (vl);
 	      return CMD_FAILURE;
@@ -278,7 +278,7 @@
       free (vl);
     }
 
-  return lex_end_of_command ();
+  return lex_end_of_command (lexer);
 }
 
 static void
Index: src/language/dictionary/value-labels.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/value-labels.c,v
retrieving revision 1.9
diff -b -w -U3 -r1.9 value-labels.c
--- src/language/dictionary/value-labels.c	26 Oct 2006 06:16:36 -0000	1.9
+++ src/language/dictionary/value-labels.c	11 Nov 2006 00:13:15 -0000
@@ -38,39 +38,40 @@
 
 /* Declarations. */
 
-static int do_value_labels (const struct dictionary *dict, int);
+static int do_value_labels (struct lexer *, 
+			    const struct dictionary *dict, int);
 static int verify_val_labs (struct variable **vars, size_t var_cnt);
 static void erase_labels (struct variable **vars, size_t var_cnt);
-static int get_label (struct variable **vars, size_t var_cnt);
+static int get_label (struct lexer *, struct variable **vars, size_t var_cnt);
 
 /* Stubs. */
 
 int
-cmd_value_labels (struct dataset *ds)
+cmd_value_labels (struct lexer *lexer, struct dataset *ds)
 {
-  return do_value_labels (dataset_dict (ds), 1);
+  return do_value_labels (lexer, dataset_dict (ds), 1);
 }
 
 int
-cmd_add_value_labels (struct dataset *ds)
+cmd_add_value_labels (struct lexer *lexer, struct dataset *ds)
 {
-  return do_value_labels (dataset_dict (ds), 0);
+  return do_value_labels (lexer, dataset_dict (ds), 0);
 }
 
 /* Do it. */
 
 static int
-do_value_labels (const struct dictionary *dict, int erase)
+do_value_labels (struct lexer *lexer, const struct dictionary *dict, int erase)
 {
   struct variable **vars; /* Variable list. */
   size_t var_cnt;         /* Number of variables. */
   int parse_err=0;        /* true if error parsing variables */
 
-  lex_match ('/');
+  lex_match (lexer, '/');
   
-  while (token != '.')
+  while (lex_token (lexer) != '.')
     {
-      parse_err = !parse_variables (dict, &vars, &var_cnt, 
+      parse_err = !parse_variables (lexer, dict, &vars, &var_cnt, 
 				    PV_SAME_TYPE) ;
       if (var_cnt < 1)
 	{
@@ -81,17 +82,17 @@
         goto lossage;
       if (erase)
         erase_labels (vars, var_cnt);
-      while (token != '/' && token != '.')
-	if (!get_label (vars, var_cnt))
+      while (lex_token (lexer) != '/' && lex_token (lexer) != '.')
+	if (!get_label (lexer, vars, var_cnt))
           goto lossage;
 
-      if (token != '/')
+      if (lex_token (lexer) != '/')
 	{
 	free (vars);
 	break;
 	}
 
-      lex_get ();
+      lex_get (lexer);
 
       free (vars);
     }
@@ -99,7 +100,7 @@
   if (parse_err)
     return CMD_FAILURE;
 
-  return lex_end_of_command ();
+  return lex_end_of_command (lexer);
 
  lossage:
   free (vars);
@@ -141,54 +142,56 @@
 /* Parse all the labels for the VAR_CNT variables in VARS and add
    the specified labels to those variables.  */
 static int
-get_label (struct variable **vars, size_t var_cnt)
+get_label (struct lexer *lexer, struct variable **vars, size_t var_cnt)
 {
   /* Parse all the labels and add them to the variables. */
   do
     {
       union value value;
-      char *label;
+      struct string label;
       size_t i;
 
       /* Set value. */
       if (vars[0]->type == ALPHA)
 	{
-	  if (token != T_STRING)
+	  if (lex_token (lexer) != T_STRING)
 	    {
-              lex_error (_("expecting string"));
+              lex_error (lexer, _("expecting string"));
 	      return 0;
 	    }
-	  buf_copy_str_rpad (value.s, MAX_SHORT_STRING, ds_cstr (&tokstr));
+	  buf_copy_str_rpad (value.s, MAX_SHORT_STRING, ds_cstr (lex_tokstr (lexer)));
 	}
       else
 	{
-	  if (!lex_is_number ())
+	  if (!lex_is_number (lexer))
 	    {
-	      lex_error (_("expecting integer"));
+	      lex_error (lexer, _("expecting integer"));
 	      return 0;
 	    }
-	  if (!lex_is_integer ())
-	    msg (SW, _("Value label `%g' is not integer."), tokval);
-	  value.f = tokval;
+	  if (!lex_is_integer (lexer))
+	    msg (SW, _("Value label `%g' is not integer."), lex_tokval (lexer));
+	  value.f = lex_tokval (lexer);
 	}
-      lex_get ();
+      lex_get (lexer);
 
       /* Set label. */
-      if (!lex_force_string ())
+      if (!lex_force_string (lexer))
 	return 0;
-      if (ds_length (&tokstr) > 60)
+      
+      ds_init_string (&label, lex_tokstr (lexer));
+
+      if (ds_length (&label) > 60)
 	{
 	  msg (SW, _("Truncating value label to 60 characters."));
-	  ds_truncate (&tokstr, 60);
+	  ds_truncate (&label, 60);
 	}
-      label = ds_cstr (&tokstr);
 
       for (i = 0; i < var_cnt; i++)
-        val_labs_replace (vars[i]->val_labs, value, label);
+        val_labs_replace (vars[i]->val_labs, value, ds_cstr (&label));
 
-      lex_get ();
+      lex_get (lexer);
     }
-  while (token != '/' && token != '.');
+  while (lex_token (lexer) != '/' && lex_token (lexer) != '.');
 
   return 1;
 }
Index: src/language/dictionary/variable-display.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/variable-display.c,v
retrieving revision 1.9
diff -b -w -U3 -r1.9 variable-display.c
--- src/language/dictionary/variable-display.c	26 Oct 2006 06:16:36 -0000	1.9
+++ src/language/dictionary/variable-display.c	11 Nov 2006 00:13:15 -0000
@@ -36,7 +36,7 @@
    It affects nothing but GUIs
 */
 int
-cmd_variable_alignment (struct dataset *ds)
+cmd_variable_alignment (struct lexer *lexer, struct dataset *ds)
 {
   do
     {
@@ -46,16 +46,16 @@
       size_t i;
       enum alignment align;
 
-      if (!parse_variables (dataset_dict (ds), &v, &nv, PV_NONE))
+      if (!parse_variables (lexer, dataset_dict (ds), &v, &nv, PV_NONE))
         return CMD_FAILURE;
 
-      if ( lex_force_match('(') ) 
+      if ( lex_force_match (lexer, '(') ) 
 	{
-	  if ( lex_match_id("LEFT"))
+	  if ( lex_match_id (lexer, "LEFT"))
 	    align = ALIGN_LEFT;
-	  else if ( lex_match_id("RIGHT"))
+	  else if ( lex_match_id (lexer, "RIGHT"))
 	    align = ALIGN_RIGHT;
-	  else if ( lex_match_id("CENTER"))
+	  else if ( lex_match_id (lexer, "CENTER"))
 	    align = ALIGN_CENTRE;
 	  else 
             {
@@ -63,7 +63,7 @@
               return CMD_FAILURE; 
             }
 
-	  lex_force_match(')');
+	  lex_force_match (lexer, ')');
 	}
       else 
         {
@@ -75,12 +75,12 @@
 	v[i]->alignment = align;
 
 
-      while (token == '/')
-	lex_get ();
+      while (lex_token (lexer) == '/')
+	lex_get (lexer);
       free (v);
 
     }
-  while (token != '.');
+  while (lex_token (lexer) != '.');
   return CMD_SUCCESS;
 }
 
@@ -89,7 +89,7 @@
    It affects nothing but GUIs
 */
 int
-cmd_variable_width (struct dataset *ds)
+cmd_variable_width (struct lexer *lexer, struct dataset *ds)
 {
   do
     {
@@ -97,33 +97,33 @@
       size_t nv;
       size_t i;
 
-      if (!parse_variables (dataset_dict (ds), &v, &nv, PV_NONE))
+      if (!parse_variables (lexer, dataset_dict (ds), &v, &nv, PV_NONE))
         return CMD_FAILURE;
 
-      if ( lex_force_match('(') ) 
+      if ( lex_force_match (lexer, '(') ) 
 	{
-	  if ( lex_force_int()) 
-	    lex_get();
+	  if ( lex_force_int (lexer)) 
+	    lex_get (lexer);
 	  else
 	    return CMD_FAILURE;
-	  lex_force_match(')');
+	  lex_force_match (lexer, ')');
 	}
 
       for( i = 0 ; i < nv ; ++i ) 
-	  v[i]->display_width = tokval;
+	  v[i]->display_width = lex_tokval (lexer);
 
-      while (token == '/')
-	lex_get ();
+      while (lex_token (lexer) == '/')
+	lex_get (lexer);
       free (v);
 
     }
-  while (token != '.');
+  while (lex_token (lexer) != '.');
   return CMD_SUCCESS;
 }
 
 /* Set variables' measurement level */
 int
-cmd_variable_level (struct dataset *ds)
+cmd_variable_level (struct lexer *lexer, struct dataset *ds)
 {
   do
     {
@@ -132,16 +132,16 @@
       enum measure level;
       size_t i;
 
-      if (!parse_variables (dataset_dict (ds), &v, &nv, PV_NONE))
+      if (!parse_variables (lexer, dataset_dict (ds), &v, &nv, PV_NONE))
         return CMD_FAILURE;
 
-      if ( lex_force_match('(') ) 
+      if ( lex_force_match (lexer, '(') ) 
 	{
-	  if ( lex_match_id("SCALE"))
+	  if ( lex_match_id (lexer, "SCALE"))
 	    level = MEASURE_SCALE;
-	  else if ( lex_match_id("ORDINAL"))
+	  else if ( lex_match_id (lexer, "ORDINAL"))
 	    level = MEASURE_ORDINAL;
-	  else if ( lex_match_id("NOMINAL"))
+	  else if ( lex_match_id (lexer, "NOMINAL"))
 	    level = MEASURE_NOMINAL;
 	  else 
             {
@@ -149,7 +149,7 @@
               return CMD_FAILURE; 
             }
 
-	  lex_force_match(')');
+	  lex_force_match (lexer, ')');
 	}
       else
         {
@@ -161,11 +161,11 @@
 	v[i]->measure = level ;
 
 
-      while (token == '/')
-	lex_get ();
+      while (lex_token (lexer) == '/')
+	lex_get (lexer);
       free (v);
 
     }
-  while (token != '.');
+  while (lex_token (lexer) != '.');
   return CMD_SUCCESS;
 }
Index: src/language/dictionary/variable-label.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/variable-label.c,v
retrieving revision 1.10
diff -b -w -U3 -r1.10 variable-label.c
--- src/language/dictionary/variable-label.c	26 Oct 2006 06:16:36 -0000	1.10
+++ src/language/dictionary/variable-label.c	11 Nov 2006 00:13:15 -0000
@@ -35,42 +35,45 @@
 #define _(msgid) gettext (msgid)
 
 int
-cmd_variable_labels (struct dataset *ds)
+cmd_variable_labels (struct lexer *lexer, struct dataset *ds)
 {
   do
     {
       struct variable **v;
+      struct string label;
       size_t nv;
 
       size_t i;
 
-      if (!parse_variables (dataset_dict (ds), &v, &nv, PV_NONE))
+      if (!parse_variables (lexer, dataset_dict (ds), &v, &nv, PV_NONE))
         return CMD_FAILURE;
 
-      if (token != T_STRING)
+      if (lex_token (lexer) != T_STRING)
 	{
 	  msg (SE, _("String expected for variable label."));
 	  free (v);
 	  return CMD_FAILURE;
 	}
-      if (ds_length (&tokstr) > 255)
+
+      ds_init_string (&label, lex_tokstr (lexer) );
+      if (ds_length (&label) > 255)
 	{
 	  msg (SW, _("Truncating variable label to 255 characters."));
-	  ds_truncate (&tokstr, 255);
+	  ds_truncate (&label, 255);
 	}
       for (i = 0; i < nv; i++)
 	{
 	  if (v[i]->label)
 	    free (v[i]->label);
-	  v[i]->label = ds_xstrdup (&tokstr);
+	  v[i]->label = ds_xstrdup (&label);
 	}
 
-      lex_get ();
-      while (token == '/')
-	lex_get ();
+      lex_get (lexer);
+      while (lex_token (lexer) == '/')
+	lex_get (lexer);
       free (v);
     }
-  while (token != '.');
+  while (lex_token (lexer) != '.');
   return CMD_SUCCESS;
 }
 
